<script>
import { ref, computed, onMounted, reactive } from "vue";
import useValidate from "@vuelidate/core";
import { required, email, minLength, sameAs, helpers } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading },
  name: 'UserForm',
  props: {
    title: String,
    data: Object
  },
  data(){
    return{
      formTitle : this.title,
      formData : this.data,
      addStatus : this.title == 'Add User',
      formId : this.title != 'Add User' ? this.data.id : null,
      viewStatus : this.title == 'View Detail User'
    }
  },
  setup() {
    const success = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
      name: '',
      username: '',
      password: 'Kulakan123',
      email: '',
      mobile: '',
      userRole : '',
      userType:''
    });
    const rules = computed(() => {
      return {
        name: { required },
        username: { required },
        email: { required },
        mobile: { required },
        userRole: { required },
        userType: { required },
      }
    });
    const v$ = useValidate(rules, state)
    async function fetchData() {
      loading.value = true;
      const result = await HTTP.get(`users`).then(response => {
        console.log(response.data)
      })
          .catch(e => {
            console.log(e)
          })
      loading.value = false;
    }
    async function saveData() {
      loading.value = true;
      const requestData = {
        id: this.formId,
        name: state.name,
        username: state.username,
        password: state.password,
        email: state.email,
        mobile: state.mobile,
        userRole: state.userRole,
        userType: state.userType
      }
      if(this.formId){
        console.log(requestData)
        const result = await HTTP.put('users/' + this.formId, JSON.stringify(requestData)).then(response => {
          success.value = response.data.message
          setTimeout(() => {
            this.$emit('form-modal-done')
          }, 1000)
        })
            .catch(e => {
              const jsonError = e.toJSON();
              error.value = jsonError.message

            })
      } else {
        const result = await HTTP.post(`register`, JSON.stringify(requestData)).then(response => {
          success.value = response.data.message
          setTimeout(() => {
            this.$emit('form-modal-done')
          }, 1000)
        })
            .catch(e => {
              const jsonError = e.toJSON();
              error.value = jsonError.message

            })
      }
      loading.value = false;
    }

    onMounted(() => {
      // console.log(saveData());
    });

    return {
      success,
      loading,
      error,
      state,
      v$,
      saveData
    };
  },methods: {
    onSubmit(e) {
      this.v$.$validate()
      if(!this.v$.$error){
        this.saveData()
      }
      e.preventDefault()
    },
    onReset() {
      e.preventDefault()
    }
  },mounted(){
    if(!this.addStatus){
      // this.state.id = this.formId
      this.state.name = this.formData.name
      this.state.password = this.formData.password
      this.state.username = this.formData.username
      this.state.email = this.formData.email
      this.state.mobile = this.formData.mobile
      this.state.userRole = this.formData.userRole
      this.state.userType = this.formData.userType
    }
  }
}
</script>
<template>
  <Loading v-if="loading"/>
  <b-form v-if="!loading" @submit="onSubmit" @reset="onReset">
    <div class="card">
      <div class="card-header d-flex justify-content-between">
        <div class="header-title">
          <h4 class="card-title">
            {{formTitle}}
          </h4>
        </div>
        <a class="badge bg-warning mr-2" href="#" @click="$emit('close-modal')"><i class="ri-arrow-go-back-fill mr-0"></i></a>
      </div>
      <div class="col-md-12" v-if="error || success">
        <div class="alert alert-danger" v-if="error">
          <div class="iq-alert-text">
            {{error}}
          </div>
        </div>
        <div class="alert alert-success" v-if="success">
          <div class="iq-alert-text">
            {{success}}
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          <div class="form-group">
            <label>Name *</label>
            <input v-model="state.name" type="text" class="form-control" :class = "{'is-invalid' : v$.name.$error }" placeholder="Enter Name" data-errors="Please Enter Name." :disabled = "viewStatus" required>
            <div class="help-block with-errors" v-if="v$.name.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.name.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Username *</label>
            <input v-model="state.username" type="text" class="form-control" placeholder="Enter Code" data-errors="Please Enter Username." :disabled = "viewStatus" required>
            <div class="help-block with-errors" v-if="v$.username.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.code.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Email *</label>
            <input v-model="state.email" type="email" class="form-control" placeholder="Enter Price" data-errors="Please Enter Email." :disabled = "viewStatus" required>
            <div class="help-block with-errors"  v-if="v$.email.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.price.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>Mobile *</label>
            <input v-model="state.mobile" type="number" class="form-control" placeholder="Enter Price" data-errors="Please Enter Mobile." :disabled = "viewStatus" required>
            <div class="help-block with-errors"  v-if="v$.mobile.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.price.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>User Role *</label>
            <select v-model="state.userRole" name="type" class="form-control" :disabled = "viewStatus" required >
              <option>USER</option>
              <option>ADMIN</option>
            </select>
            <div class="help-block with-errors"  v-if="v$.userRole.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.unit.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <label>User Type *</label>
            <select v-model="state.userType" name="type" class="form-control" :disabled = "viewStatus" required >
              <option>USER</option>
              <option>ADMIN</option>
            </select>
            <!--                        <input v-model="state.unit" type="text" class="form-control" placeholder="Enter Unit" data-errors="Please Enter Cost." :disabled = "viewStatus" required>-->
            <div class="help-block with-errors"  v-if="v$.userType.$error" >
              <div class="alert alert-danger">
                <div class="iq-alert-text">
                  {{v$.unit.$errors[0].$message}}
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
      <div class="col-md-12">
        <button v-if="!viewStatus" type="submit" class="btn btn-primary btn-block">Save</button>
        <!--                <button v-if="!viewStatus" type="submit" class="btn btn-danger btn-block">Delete</button>-->
        <button v-if="!viewStatus && addStatus" type="reset" class="btn btn-danger btn-block">Reset</button>
      </div>
    </div>
  </b-form>
</template>
<style scoped>
.col-md-12:nth-child(2) > .form-group:first-child{
  margin-top: 1rem;
}
.row{
  padding: 1rem;
}
</style>
